      program convert
c
      implicit none
c
      integer i,nmax,mag,nf,np,n,logp,nm,ns,n4
      parameter (nmax=1000000)
      integer fil(nmax),dumi(10),flm(nmax)
      real df(nmax,3),dumr(14),psi(nmax),theta(nmax)
      real phi(nmax),shx(nmax),shy(nmax),x,y
      real sig,occ(nmax),pres,pi,psize,cpsi,spsi
      parameter (pi=3.1415926535897)
      character*200 fname1,fname2,fname3,fname4
      character*200 fname5,fname6
      character dumc*4
c
      write(*,*) 'Input magnification (e.g. 45000)?'
      read(*,*) mag
      write(*,*) mag
      write(*,*)
      write(*,*) 'Input pixel size [A] (e.g. 1.2)?'
      read(*,*) psize
      write(*,*) psize
      write(*,*)
      write(*,*) 'Input CTF-filament list?'
      write(*,*) 'Example data line:'
      write(*,*) '0001    9372.87     8281.70     1091.17'//
     +           '     -0.35          0.00        0.00   0.1590'
      read(*,*) fname1
      write(*,*) fname1
      write(*,*)
      write(*,*) 'Input segment-micrograph list?'
      write(*,*) 'Example data line:'
      write(*,*) '    1 8   1.00000       1.00000       '//
     +           '594.000       1410.00       319.923      '//
     +           '0.918147      0.855234      -6.63000'
      read(*,*) fname2
      write(*,*) fname2
      write(*,*)
      write(*,*) 'Input alignment parameters?'
      write(*,*) 'Example data line:'
      write(*,*) '         1   14   0.00000       88.0000'//
     +'       84.9200       926.000       1.00000       '//
     +'249.470       5.23000       6.20000       21.0000'//
     +'       4.50000       951.620       232.680       '//
     +'5.74000      -1.29000'
      read(*,*) fname3
      write(*,*) fname3
      write(*,*)
      write(*,*) 'Input 4x alignment parameters (* = none)?'
      write(*,*) 'Example data line:'
      write(*,*) '         1   14   0.00000       84.0000'//
     +'       88.4500       377.000       1.00000       '//
     +'230.510       1.89000       2.32000       643.000'//
     +'       64.2000       359.990       231.130       '//
     +'1.26000      -1.56000'
      read(*,*) fname4
      write(*,*) fname4
      write(*,*)
      write(*,*) 'Input selection file (* = none)?'
      write(*,*) 'Example data line:'
      write(*,*) '    1 1   17.0000'
      read(*,*) fname5
      write(*,*) fname5
      write(*,*)
      write(*,*) 'Output Frealign parameter file?'
      read(*,*) fname6
      write(*,*) fname6
c
      open(10,file=fname1,status='old')
      open(11,file=fname2,status='old')
      open(12,file=fname3,status='old')
      if (fname4.ne."*") open(13,file=fname4,status='old')
      if (fname5.ne."*") open(14,file=fname5,status='old')
      open(15,file=fname6,status='unknown')
c
      logp=1000
      sig=1.0
      pres=0.0
      do 11 i=1,nmax
        df(i,1)=0
11    continue
c
      n=1
10    continue
      read(10,*,err=10,end=20)dumi(1),(dumr(i),i=1,7)
      if (dumi(1).gt.nmax) then
        write(*,*) 'ERROR: Micrograph numbers too large'
        goto 9999
      endif
      df(dumi(1),1)=dumr(1)
      df(dumi(1),2)=dumr(2)
      df(dumi(1),3)=dumr(4)
      n=n+1
      goto 10
c
20    continue
      nf=n-1
      write(*,*)
      write(*,*) fname1
      write(*,*) 'Number of micrographs read = ',nf
c
      n=1
60    continue
      read(11,*,err=60,end=70)dumi(1),dumi(2),(dumr(i),i=1,8)
      flm(n)=dumr(1)
      fil(n)=dumr(2)
      n=n+1
      goto 60
c
70    continue
      nm=n-1
      write(*,*)
      write(*,*) fname2
      write(*,*) 'Number of segments read = ',nm
c
      n=1
30    continue
      read(12,*,err=30,end=40)dumi(1),dumi(2),dumr(1),
     +  theta(n),phi(n),(dumr(i),i=2,9),psi(n),x,y
      psi(n)=-psi(n)
c      theta(n)=-theta(n)
c      phi(n)=-phi(n)
      cpsi=cos(psi(n)/180.0*pi)
      spsi=sin(psi(n)/180.0*pi)
      shx(n)=-(x*cpsi+y*spsi)
      shy(n)=-(-x*spsi+y*cpsi)
      n=n+1
      goto 30
c
40    continue
      np=n-1
      write(*,*)
      write(*,*) fname3
      write(*,*) 'Number of segments read = ',np
c
      if (np.ne.nm) then
        write(*,*) 'ERROR: Incompatible lists'
        goto 9999
      endif
c
      if (fname4.ne."*") then
c
      n=1
110   continue
      read(13,*,err=110,end=100)dumi(1),dumi(2),(dumr(i),i=1,14)
      shx(n)=shx(n)+int(4.0*dumr(14)*sin(dumr(12)/180.0*pi))
      shy(n)=shy(n)-int(4.0*dumr(14)*cos(dumr(12)/180.0*pi))
      n=n+1
      goto 110
c
100   continue
      n4=n-1
      write(*,*)
      write(*,*) fname4
      write(*,*) 'Number of segments read = ',n4
c
      if (n4.ne.nm) then
        write(*,*) 'ERROR: Incompatible lists'
        goto 9999
      endif
c
      endif
c
      if (fname5.ne."*") then
c
      do 81 i=1,nmax
        occ(i)=0.0
81    continue
      n=1
80    continue
      read(14,*,err=80,end=90)dumi(1),dumi(2),dumr(1)
      if (dumr(1).gt.np) then
        write(*,*)
     +  'ERROR: Selection outside particle range'
        goto 9999
      endif
      occ(nint(dumr(1)))=100.0
      n=n+1
      goto 80
c
90    continue
      ns=n-1
      write(*,*)
      write(*,*) fname5
      write(*,*) 'Number of selections read = ',ns
c
      else
c
      do 82 i=1,nmax
        occ(i)=100.0
82    continue
c
      endif
c
      do 50 i=1,np
c
        shx(i)=shx(i)*psize
        shy(i)=shy(i)*psize
        psi(i)=psi(i)+360.0
        if (theta(i).gt.180.0) then
          theta(i)=360.0-theta(i)
          psi(i)=psi(i)-180.0
          phi(i)=phi(i)+180.0
        endif
        n=flm(i)
        if (df(n,1).eq.0.0) then
          write (*,*)
     +  ' ERROR: Referenced micrograph does not exist'
          goto 9999
        endif
        write(15,7011)i,psi(i),theta(i),phi(i),shx(i),
     +    shy(i),mag,fil(i),df(n,1),df(n,2),df(n,3),
     +    occ(i),logp,sig,pres,0.0
7011    FORMAT(I7,3F8.2,2F10.2,I8,I6,2F9.1,2F8.2,I10,
     +         F11.4,2F8.2)
c
50    continue
c
9999  continue
c
      close(10)
      close(11)
      close(12)
      if (fname4.ne."*") close(13)
      if (fname5.ne."*") close(14)
      close(15)
c
      end

